#!/usr/bin/env python
"""
Generate positions to sample lightfield with hanging plotter.

"""
import numpy as np
import time
import sys
from math import *
from time import sleep
import struct
import argparse

# Define command line argument interface
parser = argparse.ArgumentParser(description='Generate positions to sample lightfield with hanging plotter. (argparse library is required)')
parser.add_argument('outfile',
        help='output positions (in X,Y inch coordinates)')
parser.add_argument("xpos0", help="x coord of top left of drawing in inches",
                    type=float, default=0.0)
parser.add_argument("ypos0", help="y coord of top left of drawing in inches",
                    type=float, default=0.0)
parser.add_argument("width", help="width of grid in inches",
                    type=float, default=17.0)
parser.add_argument("height", help="width of grid in inches",
                    type=float, default=14.0)
parser.add_argument("xsteps", help="number of steps along x",
                    type=float, default=8.0)
parser.add_argument("ysteps", help="number of steps along y",
                    type=float, default=6.0)

args = parser.parse_args()

outfname = args.outfile

count = None
startTime = None
numpoints = None
outf = None
lastz = -1
writebuff = []

def main():
    
    # check arguments
    # begin gcode writing to buffer

           
##    pathcount = 0
##    count = 0
##    last = [xpos0, ypos0, 0.0, 0.0]
##    pathpoints = 0

    xpos0 = float(args.xpos0)
    ypos0 = float(args.ypos0)
    xsteps = int(args.xsteps)
    ysteps = int(args.ysteps)
    
    xinc = (float(args.width) / float(xsteps))
    yinc = (float(args.height) / float(ysteps))

    xpos = xpos0
    ypos = ypos0
    for y in range(ysteps):
        first = True
        for x in range(xsteps):

                xpos = (x * xinc) + xpos0
                ypos = (y * yinc) + ypos0

                if first:
                    writebuff.append("{0}\t{1}\t0.0\t-1.0".format(xpos, ypos))
                    first = False

                writebuff.append("{0}\t{1}\t1.0\t-1.0".format(xpos, ypos))                
                
                #writebuff.append("{0}\t{1}\t0.0\t-1.0".format(xpos, ypos))                


    # dump contents to file
    outf = open(outfname, "w")

    for item in writebuff:
        outf.write(item+"\n")

    outf.close()

    # exit
##    print "({0} lines, {1} paths written to {2} in {3:.2f} sec elapsed)".format(len(writebuff), pathcount, outfname, time.time() - startTime)
##    print "Bounding Box: {0}, {1} {2}, {3}".format(minx, miny, maxx, maxy)
##    
if __name__ == "__main__":
    main()
    
